﻿Public Class Piece
    Public Picture As Bitmap
    Public HomeLocation, CurrentLocation As Rectangle

    Public Sub New(ByVal new_picture As Bitmap, ByVal home_location As Rectangle)
        Picture = new_picture
        HomeLocation = home_location
    End Sub

    ' Return true if the piece is in its home position.
    Public Function IsHome() As Boolean
        Return HomeLocation.Equals(CurrentLocation)
    End Function

    ' Return true if this position is within
    ' the piece's current location.
    Public Function Contains(ByVal pt As Point) As Boolean
        Return CurrentLocation.Contains(pt)
    End Function

    ' If the piece is close to its home position, move it there.
    Public Function SnapToHome() As Boolean
        If ((Math.Abs(CurrentLocation.X - HomeLocation.X) < 20) AndAlso _
            (Math.Abs(CurrentLocation.Y - HomeLocation.Y) < 20)) _
        Then
            CurrentLocation = HomeLocation
            Return True
        End If

        Return False
    End Function
End Class
